#include <iostream>
#include <new>
using namespace std;

struct student
{
    char imie[20];
    char nazwisko[20];
    float ocena;
    
    student *nastepny;
};

student wczytaj_studenta();
student *dodaj_wpis(student opis, student *poczatek);
void wypisz_liste(student *poczatek);
void usun_liste(student *poczatek);

int main()
{
// Wskaznik do poczatku listy studentow
student *lista = NULL;

// Wynik pytania do uzytkownika
char odpowiedz;

    cout<<"Program utworzy liste studentow" << endl << endl;
    do
    {
	// Zapytaj, czy kontynuujemy wpisywanie
	do
	{
	    cout<<"Podajesz dane nowego studenta? [t/n]: ";
	    cin>>odpowiedz;
	    cin.ignore();
	}
	while( odpowiedz!='t' && odpowiedz!='n' );
    
	if(odpowiedz == 't')
	{
	student dodawany, *poczatek;
	
	    dodawany = wczytaj_studenta();
	    poczatek = dodaj_wpis(dodawany, lista);
	    if(poczatek != NULL)
		lista = poczatek;
	    else
		cout<<"Nie powiodlo sie dodanie studenta do bazy"<<endl;
	}
    }
    while(odpowiedz == 't');
    
    cout<<"Wypiszemy teraz zebrane dane:" << endl << endl;
    wypisz_liste(lista);
    
    cout<<"Na koniec nalezy usunac liste z pamieci" << endl;
    usun_liste(lista);
}

student wczytaj_studenta()
{
student wynik;

    cout<<"Podaj imie: ";
    cin.getline(wynik.imie, sizeof(wynik.imie));
    
    cout<<"Podaj nazwisko: ";
    cin.getline(wynik.nazwisko, sizeof(wynik.nazwisko));
    
    cout<<"Podaj ocene: ";
    cin>>wynik.ocena;
    cin.ignore();
    cout<<endl;
    
    wynik.nastepny = NULL;
    return wynik;
}

student *dodaj_wpis(student opis, student *poczatek)
{
student *nowy;

    // Tworzymy dynamicznie nowa strukture "student"
    try {
	nowy = new student;
    }
    catch(bad_alloc) {
	// W wypadku bledu alokacji funkcja zwraca wskaznik NULL
	return NULL;
    }
    
    // Kopiujemy dane do pamieci
    *nowy = opis;
    
    // Wstawiamy nowy element na poczatek listy
    nowy->nastepny = poczatek;
    
    // Zwracamy informacje, gdzie obecnie jest poczatek listy
    return nowy;
}

void wypisz_liste(student *poczatek)
{
     if(poczatek == NULL)
     {
        cout << "Lista jest pusta" << endl << endl;
	return;
     }
     else
     {
     unsigned long i = 1;
     student *aktualny;
     
        aktualny = poczatek;
	cout << "Lista studentow zawiera nastepujace wpisy:" << endl << endl;
	while(aktualny != NULL)
	{
	    // Wypisz pojedyncza strukture
	    cout << "***** Wpis numer " << i << " *****" << endl;
	    cout << "Imie: \t\t" << aktualny->imie << endl;
	    cout << "Nazwisko: \t" << aktualny->nazwisko << endl;
	    cout << "Ocena: \t\t" << aktualny->ocena << endl << endl;
	    
	    // Zaktualizuj licznik rekordow bazy
	    i++;
	    
	    // Przejscie do kolejnego elementu na liscie
	    aktualny = aktualny->nastepny;
	}
    }
}

void usun_liste(student *poczatek)
{
student *kasowany, *kolejny;

    // Dla pustej listy nie ma nic do robienia
    if(poczatek == NULL) return;

    // Zaczynajac od poczatku listy...    
    kasowany = poczatek;
    while(kasowany != NULL)
    {
	// Zapamietaj, gdzie jest kolejny element - PRZED kasowaniem obecnego
	kolejny = kasowany->nastepny;
	
	// KASUJ rozwazany obecnie element listy
	delete kasowany;
	
	// W nastepnym kroku petli kasuj kolejny element
	kasowany = kolejny;
    }    
}
